// NFC [NHN Foundation Class]
//
//
// Copyright (C) 2006, nhn corp
// All rights reserved.

// $Id: RWLock.cpp,v 1.2 2006/07/29 06:09:22 taekwonv Exp $

#include "StdAfx.h"
#include "rwlock.h"

using namespace nfc;

CRWLock::CRWLock(void) : m_nActiveReaders(0),
	m_nWaitingReaders(0),
	m_nActiveWriters(0),
	m_nWaitingWriters(0)
{
}

CRWLock::~CRWLock(void)
{
}

void CRWLock::ReadLock()
{
	m_mutex.Lock();

	if (m_nActiveWriters > 0 || m_nWaitingWriters > 0)
	{
		m_mutex.Unlock();
		m_semaReaders.Lock();
	}
	else
	{
		m_nActiveReaders++;
		m_mutex.Unlock();
	}	
}

void CRWLock::ReadUnlock()
{
	m_mutex.Lock();
	
	m_nActiveReaders--;

	if (m_nActiveReaders == 0 && m_nWaitingWriters > 0)
	{
		m_nActiveWriters = 1;
		m_nWaitingWriters--;
		m_mxWriters.Unlock();
	}

	m_mutex.Unlock();
}

void CRWLock::WriteLock()
{
	m_mutex.Lock();

	if (m_nActiveWriters > 0 || m_nActiveReaders > 0)
	{
		m_nWaitingWriters++;
		m_mutex.Unlock();
		m_mxWriters.Lock();
	}
	else
	{
		m_nActiveWriters = 1;
		m_mutex.Unlock();
	}
}

void CRWLock::WriteUnlock()
{
	m_mutex.Lock();

	m_nActiveWriters = 0;

	if (m_nWaitingWriters > 0)
	{
		m_nWaitingWriters--;		
		m_mxWriters.Unlock();
	}
	else if (m_nWaitingReaders > 0)
	{		
		m_nActiveReaders = m_nWaitingReaders;
		m_nWaitingReaders = 0;
		m_semaReaders.Unlock();
	}

	m_mutex.Unlock();
}
